/* FILE: ocport.h             -*-Mode: c++-*-
 *
 * Machine specific #define's and typedef's, generated by [Oc_MakePortHeader]
 *
 */

#ifndef _OC_PORT
#define _OC_PORT

#include <float.h>
#include <limits.h>
#include <math.h>
#define MEMBLOCKSIZE 4096 /* Natural system memory blocksize.  Shouldn't  */
               /* affect program correctness, but may affect performance. */

// See Stroustrup, Section 16.1.3.
#include <exception>		// The base class std::exception and the
				// standard exception std::bad_exception
#include <new>			// The standard exception std::bad_alloc
#include <typeinfo>		// The standard exceptions std::bad_cast
				// and std::bad_typeid
#define OC_THROW(x) throw x


/* End includes */
#define CONFIG_TCL_MAJOR_VERSION 8
#define CONFIG_TCL_MINOR_VERSION 4
#define CONFIG_TK_MAJOR_VERSION 8
#define CONFIG_TK_MINOR_VERSION 4
#define CONFIG_TCL_PATCH_LEVEL "8.4.11"
#define CONFIG_TK_PATCH_LEVEL "8.4.11"
#define CONFIG_TCL_RELEASE_LEVEL 2
#define CONFIG_TCL_RELEASE_SERIAL 11
#define CONFIG_TK_RELEASE_LEVEL 2
#define CONFIG_TK_RELEASE_SERIAL 11
#define OC_USE_STD_NAMESPACE using namespace std
#define OC_USE_EXCEPTION typedef std::exception EXCEPTION
#define OC_USE_STRING typedef std::string String

/* Substitute domain checked atan2 */
#define atan2(y,x) Oc_Atan2((y),(x))

/* Use OOMMF provided error function */
#define erf(x) Oc_Erf((x))

/* Dummy wrapper for ansi-compliant sprintf */
#define OC_SPRINTF_WRAP(x) (x)

/* Variable type declarations.  The '****#m' */
/* types are at *least* '#' bytes wide.      */
typedef  int                 BOOL;
typedef  unsigned char       BYTE;
typedef  char                CHAR;
/* typedef  signed char        SCHAR; */
/** signed type not supported by HP C++ compiler **/
typedef  unsigned char      UCHAR;

typedef  float              REAL4;
typedef  double             REAL8;
typedef  float              REAL4m;
typedef  double             REAL8m;
typedef  double             REALWIDE;  /* Widest native float */
#define REAL4_EPSILON       1.1920929e-007
#define SQRT_REAL4_EPSILON  0.000345266983
#define REAL8_EPSILON       2.2204460492503131e-016
#define SQRT_REAL8_EPSILON  1.4901161193847656e-008
#define CUBE_ROOT_REAL8_EPSILON 6.0554544523933429e-006

typedef  short               INT2;
typedef  unsigned short     UINT2;
typedef  int                 INT4;
typedef  unsigned int       UINT4;
typedef  int                 INT2m;
typedef  unsigned int       UINT2m;
typedef  int                 INT4m;
typedef  unsigned int       UINT4m;

#define POINTERWIDTH 4
#define BYTEORDER 4321

/* System type info */
#define UNIX 1
#define WINDOWS 2
#define MACINTOSH 3
#define SYSTEM_TYPE WINDOWS

/* Random number generator. Replace with your own if */
/* if you don't like rand().                        */
#define OMF_SRANDOM(seed)  srand(seed)
#define OMF_RANDOM()       rand()
#define OMF_RANDOM_MAX     RAND_MAX

/* Signal handler prototype, to work around some non-ANSI header files */
extern "C" {
typedef void(*omf_sighandler)(int);             /* ANSI version */
/* typedef void(*omf_sighandler)(int, ...); */  /* Not ANSI */
}

/* For Windows */
#define rint(x) ((x)>=0 ? double(int(x+0.5)) : double(int(x-0.5)))
 
/* NICE_DEFAULT is the priority level passed to SetPriorityClass() */
/* inside MakeNice().                                              */
#define NICE_DEFAULT IDLE_PRIORITY_CLASS
#define NICE_THREAD_DEFAULT THREAD_PRIORITY_NORMAL

/* getpid() prototype */
#include <process.h>

/* Windows header file.  NB: This defines a lot of stuff we      */
/* don't need or really want, like macros min(x,y) and max(x,y). */
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#undef WIN32_LEAN_AND_MEAN
 
/* Directory path separator; Unix uses '/', DOS uses '\'. */
/* Rumor has it that the Mac uses ':'.                    */
#define DIRSEPCHAR '\\'
#define DIRSEPSTR  "\\"
#define PATHSPLITSTR ";"

/* Definitions for Oc_TimeVal class.
 *  NOTE: For most compilers, DWORDLONG is defined in Windows header
 *        files as unsigned __int64.  Adjust as necessary to get
 *        unsigned 64 bit integer.  Alternatively, don't define the
 *        HAS_GETPROCESSTIMES to use the clock() call, and set
 *        OC_TIMEVAL_TICK_TYPE to unsigned long.
 */
#define HAS_GETPROCESSTIMES
typedef DWORDLONG OC_TIMEVAL_TICK_TYPE;
#define OC_TIMEVAL_TO_DOUBLE(x) double(x)

#endif /* _OC_PORT_H */
